#!/usr/bin/perl -w
# change the first line if you have the Perl interpreter somewhere else
# you can find it like this: which perl

# AUTHOR:		Laszlo Szathmary, szathml@delfin.klte.hu
# DATE:			October 26, 2002	
# USAGE:			./prg_name > traverse.nfo	
# PURPOSE:		it generates a template for file/dir descriptions. You just have to fill it then.

use strict;

my (@dirArray, @fileArray, $dir, $file);

foreach (<*>) {
	if (-f) {
		push(@fileArray, $_);
	}
}

foreach (<*>) {
	if (-d) {
		push(@dirArray, $_);
	}
}

print_information();

print_separator("Directories:");
foreach $dir (@dirArray)
{
	print "$dir;\n";
}

print_separator("Files:");
foreach $file (@fileArray)
{
	print "$file;\n";
}

sub print_separator
{
	my ($text) = (@_);
	my $width = length($text)+2*2;  # 2 more extra spaces before and after
	my $line = '#'x$width."\n";

	print $line."# $text\n".$line;
}

sub print_information
{
	print <<END;
#####################################################################
# You can add description to your directories and files here
# Any line starting with a hashmark (#) is treated as a comment line
#
# The first line is the description of the current directory.
# !!! It cannot contain a semi-colon (;) !!!
#
# All the other lines should look like this: 
# entry;description
#####################################################################
END
}
