#!/usr/bin/perl -w

# AUTHOR:      Laszlo Szathmary, szathml@delfin.klte.hu
# DATE:			15 January, 2003
# PROGRAM:		show_images_in_one_html.pl
# USAGE:			./show_images_in_one_html.pl > output.html
# PURPOSE:		it shows all the images in a directory in one html file

print_start_html();
$i=0;
foreach (<*>)
{
	if (-f) # if it's a file
	{
		$file = $_;
		if ($file =~ m#\.(jpe?g|png|gif)$#i)
		{
			++$i;
			$img_src = "<img src=\"$file\">";
			print <<END;
<tr>
	<td align="right">$i.</td>
	<td align="right">$file</td>
	<td align="center">$img_src</td>
</tr>
END
		}
	}
}
print_end_html();

#############################################################################

sub print_start_html
{
	print <<END;
<html>
<head>
	<title>Jabba's Image Shower</title>
</head>
<body bgcolor="#eaf1fd">
<h1>Jabba's Image Shower (in one html file)</h1>
<hr>
<table border="1" align="center">
<tr>
	<th>No.</th><th>Filename</th><th>Image</th>
</tr>
END
}

sub print_end_html
{
	print <<END;
</table>
</body>
</html>
END
}
