<?php
if (!defined('IN_PHPTRAVERSER'))
{
   die ("Hacking attempt");
}
//else

// mimetypes_20021111.php
// This file is responsible for displaying the correct icons for files/dirs
//
//	There are two possibilities to display icons to different mimetypes.
//
//	1. SIMPLE case
//		-----------
//		It means there is one icon to all the files, one icon to directories,
//		and one icon to the parent directory (3 icons altogether)
//
//	2. COMPLEX case
//		------------
//		One icon to directories, one icon to the parent dir. and different
//		icons to different files (it depends upon the extension of a file).
//		There's also a default icon to the files which are not associated
//		with any icon.
//
// About this file:
// ================
// 
// REQUIRES: $mimetypesConfigArray (it has to exist as a global variable)
// it looks like this (example):
//	$mimetypesConfigArray = array(COMPLEX,"$BASE/mimetypes/complex/26x26");
// The 2nd element of this array is a directory where the icons are stored.
// In this directory THERE MUST BE a config file whose default name is
// "_mimetype_cfg.php" (see below). The structure of this config file is
// very strict, if you leave out something IT WON'T WORK!!!
// So what is needed in this file?
// 	- $parentdir_icon_20021111
//			the icon of the parent directory
//		- $dir_icon_20021111
//			the icon of directories
//		- $file_icon_20021111
//			the icon of files in simple case and the default icon in complex case
//			(i.e. if there is no association to the given mimetype)
//
//    Note: in SIMPLE case these 3 things are enough. In COMPLEX case
//				read on.
//
//		- $mimetypesArray_20021111
//			association of icon names and extensions
//			an array with the next structure:
//				icon's name => array of extensions
//				Example: $mimetypesArray_20021111 = array (
//								"deb.png" => array("deb"),
//								"doc.png" => array("doc")
//							);
//		- $oneToOneArray_20021111
//			association of one file name to one icon
//			an array with the next structure:
//				file's name => icon's name
//				Example: $oneToOneArray_20021111 = array (
//								"core" => "core.png",
//								"Makefile" => "make.png"
//							);
//
// I repeat: these variables and arrays are needed and must be called like 
// this. Otherwise it won't work! Below in this file we will need them.

	$include_filename_20021111 = "_mimetype_cfg.php";
	include($mimetypesConfigArray[1]."/".$include_filename_20021111);

/*	What to do if you want to use your own icons?
	=============================================
	1. put them into a directory
	2. in traverse.php change the $mimetypesConfigArray variable to point
		to this directory, i.e.:
		$mimetypesConfigArray = array(COMPLEX,dir_containing_your_icons);
	3. read the section above and create a config file in your icons' dir.
	4. if you extended my version or you created some nice new icons,
		you won't forget to send 'em to me, right? :) I need your help here!!!
		Contact: see the beginning of traverse.php
*/

// this function returns the name of an icon (with its appropriate path too)
// Required parameter: 
// 1.	what this icon is used for (i.e. PARENTDIR, DIR or FILE)
// 2. name of the file/dir to which we want to assign an icon
function mimetypes_20021111($type_of_current_unit, $name_of_current_unit)
{
	global 	$mimetypesConfigArray, 
				$parentdir_icon_20021111, $dir_icon_20021111, $file_icon_20021111;
	$type		= $mimetypesConfigArray[0];
	$dir		= $mimetypesConfigArray[1];
	$dir_url	= $mimetypesConfigArray[2];

	$value;
	
	switch ($type_of_current_unit)
	{
		case PARENTDIR:	$value = $parentdir_icon_20021111;
								break;
		case DIR:			$value = $dir_icon_20021111;
								break;
		case FILE:			if ($type == SIMPLE) $value = $file_icon_20021111;
								else 						$value = find_icon_20021111($name_of_current_unit);
								break;
	}

	return "$dir_url/$value";
}

function find_icon_20021111($file_name)
{
	global $file_icon_20021111;
	
	if ($found = search_in_oneToOneArray_20021111($file_name)) return $found;
	//else
	if (preg_match("/(.*)\.(.*)$/",$file_name,$matches))
	{
		$ext = $matches[2];
		if ($found = search_in_mimetypesArray_20021111($ext)) return $found;
	}
	//else, i.e. if there is no extension or if not found at all
	return $file_icon_20021111;
}

function search_in_oneToOneArray_20021111($file_name)
{
	global $oneToOneArray_20021111;

	reset($oneToOneArray_20021111);
	while ( list($key, $value) = each($oneToOneArray_20021111) )
	{
		if (case_check($key) == case_check($file_name)) return $value;
	}
	//else
	return 0;
}

function search_in_mimetypesArray_20021111($ext)
{
	global $mimetypesArray_20021111;
	
	reset($mimetypesArray_20021111);
	while ( list($key, $valueArray) = each($mimetypesArray_20021111) )
	{
		foreach ($valueArray as $value)
		{
			if (case_check($value) == case_check($ext)) return $key;
		}
	}
	//else
	return 0;
}
?>
