<html>
<head>
   <title>Help for the search module for Jabba''s PHP Traverser</title>
   <meta name="author" content="Laszlo Szathmary, alias Jabba">
   <meta name="title"  content="Help for the search module">
   <link rel="stylesheet" type="text/css" href="assets/stylesheet_search.css">
   <script language="JavaScript" src="assets/open_win.js"></script>
</head>
<body>
<a name="Basic"></a>
<font class="tgtitle">Basic search</font><p>
In basic search you cannot use joker characters like * or ?. It only permits a very
basic search: complete match (is), or substring match (contains).<p>
<font class="tgtext">Examples:</font><p>
<table border="1" align="center" cellpadding="5">
<tr>
   <th>Description</th>
   <th>Mode</th>
   <th>Search command</th>
</tr>
<tr>
   <td align="center">find all the <i>mp3</i>'s</td>
   <td align="center">contains</td>
   <td align="center">mp3</td>
</tr>
<tr>
   <td align="center">find <i>terminator4.avi</i></td>
   <td align="center">is</td>
   <td align="center">terminator4.avi</td>
</tr>
</table><br>
<a href="#common" class="help">Read more</a>

<!-- -->
<hr>
<a name="Advanced"></a>
<p><font class="tgtitle">Advanced search</font><p>
This mode is much more powerful than the basic mode. Here you can use
<i>regular expressions</i> in Perl-style. What you type in are given to the
<a href="javascript: open_help_func_win('http://fr2.php.net/manual/en/function.preg-match.php')">preg_match()</a>
PHP function, but <font color="red">you don't have to put your regexp between
/.../ signs</font>! If you do not know regular expressions, you should learn them
quickly, it is much better than normal string matching.<br>
The search can be case-insensitive (default -- no difference between lower and upper case 
characters), or case-sensitive (there is difference between lower and upper case
characters). Use case-sensitive mode if you want to find something <u>exactly</u>. But as
Windows sometimes saves files with capital letters (like pic.JPG), I recommend case-insensitive 
search rather.<p>
<font class="tgtext">Examples:</font><p>
<table border="1" align="center" cellpadding="5">
<tr>
   <th>Description</th>
   <th>Case</th>
   <th>Search command</th>
</tr>
<tr>
   <td align="center">find all the <i>mp3</i>'s</td>
   <td align="center">insensitive</td>
   <td align="center">.*\.mp3</td>
</tr>
<tr>
   <td align="center">find <i>terminator4.avi</i> exactly</td>
   <td align="center">sensitive</td>
   <td align="center">^terminator4.avi$</td>
</tr>
<tr>
   <td align="center">find all the gif, jpg, png files</td>
   <td align="center">insensitive</td>
   <td align="center">.*\.(gif|png|jpg)</td>
</tr>
<tr>
   <td align="center">list all the elements from here</td>
   <td align="center">insensitive</td>
   <td align="center">.</td>
</tr>
</table><br>
<a href="#common" class="help">Read more</a>

<hr>
<a name="common"></a>
<p><font class="tgtitle">Common things in both modes</font><p>
If your search is successful you'll get a list. The lines not indented
are links to directories. The lines indented are links to files. If a file
was found, its directory is always printed either. If no files are present below
a directory it means only the name of the directory matched your criteria.<p>
<font class="tgtext">How to use the download "buttons"?</font><p>
First perform a search by typing your criteria and then press the Search button.
After this pressing the download button (if it is enabled by the site administrator)
you will get a URL list of the files. Save this file as a normal plain text file (down.txt), 
then pass it to a download manager (wget -i down.txt).<br>
With the next "button" you will get a list of files found in the current directory (it does
not go in recursively). Ideal if you want to get all the mp3 files in a directory for
instance.<br>
Whenever you type in your criteria and press the Search button, it'll always start from the 
current directory, which is the directory in the parent (main) window from where you called the
Search module. You can always get this directory back by pressing the "Show current dir" button.<p>
After having read this help, now you must be able to download everything from this site :)
</body>
</html>
