<?php
################################################################################
//
// Jabba's PHP Traverser v0.8.0
// Copyright (C) 2002, 2003  Laszlo Szathmary (szathml@delfin.unideb.hu)
//
// From http://www.hotscripts.com/Detailed/16749.html
// or   http://www.loria.fr/~szathmar/off/projects/php/phptraverse/index.php
//
// If you want to link this project, please use the first URL, the second
// may change in time.
//
// Credits: Ly0n, Jeff, Aaron, Robert, tom, Kim (sun818@TekGems), 
//          Max Headroom, Brandon, Joel, Paul Richmond, Celso Rodrigues
//
/////////////////////////////////////////////////////////////////////////////
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
############################# Quick Start Installation #########################
// put this file in a directory whose content you want to make available
// Put the assets directory somewhere in your web page, and 
// 1) modify the config file:
//      - change $BASE and $BASE_URL to point to this "assets" directory
// 2) modify this file below:
//      - change the path to the config file (require_once('.../config.inc.php'))
//    Tip: if you copy traverse.php together with the config file
//         (they are in the same dir.), you don't need to change anything here.
################################################################################

?>
<?php
   error_reporting(E_ALL ^ E_NOTICE);
   define('IN_PHPTRAVERSER', true);
// Start: include files
//
   require_once(dirname(__FILE__). '/' . 'config.inc.php');
   include("$BASE/mimetypes_20021111.php");
//
// End: include files

?>
<?php
################################################################################
## main block starts here
################################################################################

   if ($passwordAr['allow']) @session_start();

   $download_list = getValue($download_list);
   if ($download_list) header('Content-type: text/plain');

   if (!isset($PHP_SELF)) $PHP_SELF = $_SERVER["PHP_SELF"];
   $DIR_NAME           = dirname($PHP_SELF);
   $FILE_NAME          = basename($PHP_SELF);

   //these variables will get values later
   $descriptionArray = array();
   $currentDirDescription = null;
   $html = new HTMLHelper();

   if (isset($_GET['download_list']))
   {
      $dir = getDirFromQueryString($QUERY_STRING);
   }

   // A little trick to suppress any HTML output. If logging clicks is allowed, we need no HTML
   // output by the script, so we switch $download_list ON, it'll have this effect.
   // If sitemap is called, we'll do the same.
   if (isset($_GET['log_click']) && !empty($_GET['log_click']))   $download_list = 1;
   $sitemap = 0;
   if (isset($_GET['sitemap'])   && !empty($_GET['sitemap']))     { $download_list = 1; $sitemap = 1; }
   $search = 0;
   if (isset($_GET['search'])    && !empty($_GET['search']))      { $download_list = 1; $search = 1; }
   $plugin = 0;
   if (isset($_GET['plugin'])    && !empty($_GET['plugin']))      { $download_list = 1; $plugin = 1; }
   $basket = 0;
   if (isset($_GET['basket'])    && !empty($_GET['basket']))       
   { 
      $basket = $_GET['basket'];  
      if ($basket == ADD_BASKET && $plugin == 0)   $download_list = 0;
      else                                         $download_list = 1;
   }

   checkParameterDirectory();
   // if someone wants to hack you, or an invalid directory was given
   // the script STOPs here

   // else
   $cwd = preg_replace("/\/\./","","$DIR_NAME/$dir");
   $cwd = preg_replace("/\/$/","",$cwd);
   
   if ($passwordAr['allow']) check_password();
   
   if (!$download_list) $html->print_start_html($cwd);
   
   if (!$download_list)
   {
      print '<table width="99%">'.n().
            '   <tr><td>'.get_print_title(1).'</td></tr>'.n().
            '   <tr><td align="left">'.get_print_current_dir().'</td>'.n().
            '       <td align="right">'.get_print_search().get_print_manage_basket().'</td></tr>'.n().      // if search is off it prints nothing
            '   <tr><td align="left">'.get_print_fast_jump().'</td>'.n().
            '       <td align="right">'.get_print_sitemap().'</td></tr>'.n().     // if sitemap is off it prints nothing
            '</table>'.n();
      if ($presentationAr['showDownloadButtons'])    $html->print_download_list_button();
      else                                           print "<hr>\n";
   }
   
   printDirectoryContent();
   // Okay, let's print out the content at last!
   
   if (!$download_list)
   {
      if ($presentationAr['showDownloadButtons']) $html->print_download_list_button();
      else                                        print nl();
      $html->print_end_html();
   }
################################################################################
## main block ends here
################################################################################
?>
<?php
################################################################################
## Functions start here
################################################################################

// description class, it'll contain every important characteristics of a unit (dir/file)
// PHP5: this is an abstact class
class Desc
{
   var $oid;            // will be used later
   var $name;            // ex.: passwd.txt          ,i.e. just the filename, no path!
   var $link;            // when we click on it where to take us, an URL
   var $img_src;         // icon's source
   var $description;      // textual description of the dir/file
   var $dots;            // dots after the filename/dirname until the filesize
   var $link_to_plugin;   // link to the plugin
   var $log_cnt;         // how many times has it been clicked on?
   var $filesize_str;   // filesize as a string
   var $filemtime_str;   // when was it last modified? In string format.
   var $add_basket;     // add item to the basket (it'll be a link)

   function Desc($name, $oid) {
      $this->name = $name;
      $this->oid  = $oid;
      $this->description = SPACE;
   }

//   PHP5: abstract function getType();
}

// parentdir class
class DescParentdir extends Desc
{
   function DescParentdir($name, $oid) {
      parent::Desc($name, $oid);
      $this->filesize_str = DIR_END;
      $this->log_cnt = MISSING;
      $this->filemtime_str = MISSING;
      $this->add_basket    = MISSING;
   }

   function getType() { return PARENTDIR; }
}

// dir class
class DescDir extends Desc
{
   var $download_url;   // for the download list

   function DescDir($name, $oid) {
      global $presentationAr;
      parent::Desc($name, $oid);
      $this->filesize_str = DIR_END;
      $this->log_cnt = MISSING;
      $this->filemtime_str = MISSING;
      if ($presentationAr['coloumns']['basket']['allowAddDir'] == 0) $this->add_basket = MISSING;
   }

   function getType() { return DIR; }
}

// file class
class DescFile extends Desc
{
   var $ext;            // extension of the file
   var $link_normal;      // in case of files without logging
   var $download_url;   // for the download list
   var $filesize_int;   // filesize as a number
   var $filemtime_int;   // when was it last modified?

   function DescFile ($name, $oid) {
      parent::Desc($name, $oid);
      $this->ext = $this->getExtension($name);
      $this->log_cnt = 0;
   }

   function getType() { return FILE; }

   function getExtension($filename) {
      if (preg_match("/(.*)\.(.*)$/",$filename,$matches)) return $matches[2];
      // else
      return '';
   }
}

// controller class
class Control
{
   var $unitArray = array();      // list of units in the current dir.
   var $descArray = array();      // description of units, array of objects
   var $print_orderArray = array();
   var $cwd;                     // ex.:  /~szathmar/off/projects/php/test/demos/test_dir
   var $dir;                     // ex.:  ./demos/test_dir
   var $php_self;                  // ex.:  http://www.loria.fr/~szathmar/off/projects/php/test/traverse.php
   var $traverser_name;            // ex.:  traverse.php
   var $log_read_ok;               // was the log read successfully?
   var $currentDirDescription;

   function Control() {
      $this->cwd                = $GLOBALS['cwd'];
      $this->dir                = $GLOBALS['dir'];
      $this->php_self          = $GLOBALS['PHP_SELF'];
      $this->traverser_name    = $GLOBALS['FILE_NAME'];
      $this->log_read_ok      = 0;   // if the log was read without any problem, it'll be set to 1
   }

   function start() {
      $this->sort_units();
      $this->initDescArray();
      $this->basename_unitArray();
      $this->fillDescArray();
      $this->addLogInfo();
      $this->addDescriptionArray();
      #
      $this->order_by_name();
      $this->print_it_out();
   }

   function add($unit) {
      $this->unitArray[] = basename($unit);
   }

   function order_by_name($asc_desc = ASC)
   {
      $dirArray = array(); $fileArray = array();

      foreach(array_keys($this->descArray) as $key)
      {
         $ref = &$this->descArray[$key];
         if ($ref->getType() == PARENTDIR) $this->print_orderArray[] = $ref;
      }
      foreach(array_keys($this->descArray) as $key)
      {
         $ref = &$this->descArray[$key];
         if ($ref->getType() == DIR) $dirArray[] = $ref;
      }
      $this->print_orderArray = array_merge($this->print_orderArray, ($asc_desc==ASC)?$dirArray:array_reverse($dirArray));

      foreach(array_keys($this->descArray) as $key)
      {
         $ref = &$this->descArray[$key];
         if ($ref->getType() == FILE) $fileArray[] = $ref;
      }
      $this->print_orderArray = array_merge($this->print_orderArray, ($asc_desc==ASC)?$fileArray:array_reverse($fileArray));
   }

   function addDescriptionArray() {
      global $presentationAr;

      if ($presentationAr['coloumns']['description']['allow'] == FALSE) return;
      // else
      global $descriptionArray;

      $this->currentDirDescription = $GLOBALS['currentDirDescription'];
      foreach ($descriptionArray as $key=>$value)
         if (isset($this->descArray[$key]))
            $this->descArray[$key]->description = $value;
   }

   // unitArray contains path + unit-name. Change it to unit-name only
   // ex.: ./demo/try.txt   ->   try.txt
   function basename_unitArray() {
      for ($i = 0; $i < count($this->unitArray); ++$i)
         $this->unitArray[$i] = basename($this->unitArray[$i]);
   }

   // putting elements in the descArray
   function initDescArray() 
   {
      global $presentationAr;
      if ( $this->dir != '.' || (file_exists('../' . $this->traverser_name) && $presentationAr['join_to_parent'] == YES ) ) 
         $this->descArray[] = new DescParentdir("Parent Directory", 0);
      $oid_cnt = 1;
      foreach ($this->unitArray as $value)
         switch ($this->getType($this->dir . '/' . $value))
         {
            case DIR:
               $this->descArray[$value] = new DescDir($value, $oid_cnt++);
               break;
            case FILE:
               $this->descArray[$value] = new DescFile($value, $oid_cnt++);
               break;
            default:
               break;
         }
   }

   function getType($unit) {
      if (is_file($unit)) return FILE;
      else                return DIR;
   }

   function sort_units() {
      sort_array($this->unitArray);
   }

   // set the variables of the Desc objects in the array
   function fillDescArray()
   {
      foreach ( array_keys($this->descArray) as $key )
      {
         // it'll be a pointer (a reference exactly) to the current Desc object in the array
         // through this reference we can _modify_ the object
         $ref = &$this->descArray[$key];
         switch ($ref->getType())
         {
            case PARENTDIR:
            {
               global $presentationAr;
               $ref->img_src = mimetypes_20021111(PARENTDIR,""); 
               $ref->dots = dots($ref->name, $ref->filesize_str);
               if ( file_exists('../' . $this->traverser_name) && $presentationAr['join_to_parent'] == YES ) {
                  $back_dir        = dirname($this->cwd);
                  $ref->link     = $back_dir . '/' . $this->traverser_name;
               }
               else {
                  preg_match("/(.*)\/(.*)$/",$this->dir,$matches);
                  $back_dir      = urlencode($matches[1]);
                  $ref->link = $this->php_self . '?dir=' . $back_dir;
               }
               break;
            }
            case DIR:
               $ref->dots = dots($ref->name, $ref->filesize_str);
               $dir_unit_encoded = get_unit_encoded($this->dir . '/' . $ref->name);
               $ref->download_url = add_http_server_prefix($dir_unit_encoded);
               $ref->link = $this->php_self . '?dir=' . urlencode($this->dir . '/' . $ref->name);
               $ref->img_src = mimetypes_20021111(DIR,"");
               if ($presentationAr['coloumns']['basket']['allowAddDir']) 
                  $ref->add_basket = get_print_add_to_basket($ref->download_url);
               break;
            case FILE:
            {
               global $log_click, $PHP_SELF;
               $dir_unit_encoded = get_unit_encoded($this->dir . '/' . $ref->name);
               $ref->link = (($log_click['allow']) 
                  ? ("$PHP_SELF?dir=" . urlencode($this->dir) . '&' . "log_click=" . urlencode($dir_unit_encoded)) 
                  : ($dir_unit_encoded));
               $ref->link_normal = $dir_unit_encoded;
               $ref->img_src = mimetypes_20021111(FILE, $ref->name);
               // START -- for the download list
               $ref->download_url = add_http_server_prefix($dir_unit_encoded);
               // END   -- for the download list
               $ref->link_to_plugin = 
//                  plugin_selector('<img src="'.($ref->img_src).'" alt="'.FILE_END.'" border="0">',
//                                  add_http_server_prefix($this->dir),
//                                  $ref->name,DescFile::getExtension($ref->name));
                  plugin_selector_2('<img src="'.($ref->img_src).'" alt="'.FILE_END.'" border="0">',
                                  add_http_server_prefix($this->dir),
                                  $ref->name, DescFile::getExtension($ref->name));
               $ref->filesize_int = filesize($this->dir . '/' . $ref->name);
               $ref->filesize_str = file_size_to_str($ref->filesize_int);
               $ref->dots = dots($ref->name, $ref->filesize_str);
               $ref->filemtime_int = filemtime($this->dir . '/' . $ref->name);
               $ref->filemtime_str = date($log_click['date_format'],$ref->filemtime_int);
               $ref->add_basket = get_print_add_to_basket($ref->download_url);
               break;
            }
            default:
               break;
         }
      }
   }

   // sets the log_cnt variable of the Desc objects
   function addLogInfo()
   {
      global $log_click;

      $log_file = $this->dir . '/' . $log_click['file'];    // the log file
      $fp = @fopen($log_file, "r");
      if ($fp)
      {
         if (flock($fp, LOCK_SH))        ## don't do anything unless lock is successful
                                       ## lock is important as another process can write this file at the same time
         {
            while ($buffer = fgets($fp,4096))
            {
               // read in the log file, fill an array
               $buffer = perl_chomp($buffer);
               $pieces = explode($log_click['delimiter'], $buffer);
               if (isset($this->descArray[$pieces[1]])) $this->descArray[$pieces[1]]->log_cnt = $pieces[0];
            }
            flock($fp, LOCK_UN);
            $this->log_read_ok = YES;
         }
      }
   }

   // before this function we have already made a proper order of elements in the descArray
   // what this function does: takes the elements of the array one by one and prints 'em out
   function print_it_out()
   {
      global $presentationAr;

      if ($presentationAr['coloumns']['header'] == ON && $GLOBALS['download_list'] == OFF) 
         $this->print_table_header();

      foreach ($this->print_orderArray as $value)
      {
         $type = $value->getType();
         $html = &$GLOBALS['html'];

         if ($presentationAr['on_click']) $onclick_effect = $html->onclick_effect_start.$value->link.$html->onclick_effect_end;
         else                             $onclick_effect = '';

         switch ($type)
         {
            case PARENTDIR:
            case DIR:
            if (!$GLOBALS['download_list'])
            {
               if ($type == PARENTDIR) $class_html = ' class="parent"';
               else                    $class_html = '';

               print $html->tab(1) . $html->tr_open() . n();
               // we take every coloumn. If it's switched on, print the appropriate html
               // you have to modify the html output HERE. You can also add a new coloumn here,
               // but the don't forget to add it to the config file too!
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['icon'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td align="'.$align.'" width="'.$width.'">'.
                     '<img src="'.$value->img_src.'" alt="'.$value->file_size_str.' " border="0"></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['name'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align ="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed"><a'.$class_html.' href="'.$value->link.'">'.$value->name.'</a>'.$html->hidden_link_html.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['filesize'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->filesize_str.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['log'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->log_cnt.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['filemtime'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->filemtime_str.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['description'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->description.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['basket'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->add_basket.'</font></td>' . n();
               }
               ##############################################################
               print $html->tab(1) . $html->tr_close() . n();
            }
               break;
            case FILE:
            {
               if ($GLOBALS['download_list'])
               {
                  print $value->download_url . n();
                  break;
               }
               //else, if we don't want a download list

               global $presentationAr, $hidden_link;

               $spaces =& $html->spaces;
               
               print $html->tab(1) . $html->tr_open() . n();
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['icon'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td align="'.$align.'" width="'.$width.'">'.
                     $value->link_to_plugin.'</td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['name'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  if ($hidden_link['allow']) $hidden_link_html = '<a href="' . $value->link_normal . '"><img src="' . $hidden_link['pic'] . '" border="'. ($hidden_link['visible']?1:0) .'"></a>';
                  else                       $hidden_link_html = '';
                  $file_size =& $value->filesize_str;
                  print $html->tab(2) . '<td'.$onclick_effect.' align ="'.$align.'"><font class="tgfixed">'.
                     '<a href="'.$value->link.'">'.$value->name.'</a>'.$hidden_link_html.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['filesize'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$file_size.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['log'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->log_cnt.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['filemtime'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.preg_replace("/ /","&nbsp;",$value->filemtime_str).'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['description'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->description.'</font></td>' . n();
               }
               ##############################################################
               $tempAr =& $presentationAr['coloumns']['basket'];
               if ($tempAr['allow']) {
                  $width =& $tempAr['width']; $align =& $tempAr['align'];
                  print $html->tab(2) . '<td'.$onclick_effect.' align="'.$align.'" width="'.$width.'">'.
                     '<font class="tgfixed">'.$value->add_basket.'</font></td>' . n();
               }
               ##############################################################
               print $html->tab(1) . $html->tr_close() . n();
            } 
               break;
            default:
               break;
         }
      }
   }
   
   function print_table_header()
   {
      global $presentationAr, $html;
      print $html->tab(1) . '<tr>' . n();
      ##############################################################
      $tempAr =& $presentationAr['coloumns']['icon'];
      if ($tempAr['allow']) {
         $width =& $tempAr['width']; $align =& $tempAr['align'];
         print $html->tab(2) . '<th align="'.$align.'" width="'.$width.'">'.$tempAr['text'].'</td>' . n();
      }
      ##############################################################
      $tempAr =& $presentationAr['coloumns']['name'];
      if ($tempAr['allow']) {
         $width =& $tempAr['width']; $align =& $tempAr['align'];
         print $html->tab(2) . '<th align="'.$align.'" width="'.$width.'">'.$tempAr['text'].'</td>' . n();
      }
      ##############################################################
      $tempAr =& $presentationAr['coloumns']['filesize'];
      if ($tempAr['allow']) {
         $width =& $tempAr['width']; $align =& $tempAr['align'];
         print $html->tab(2) . '<th align="'.$align.'" width="'.$width.'">'.$tempAr['text'].'</td>' . n();
      }
      ##############################################################
      $tempAr =& $presentationAr['coloumns']['log'];
      if ($tempAr['allow']) {
         $width =& $tempAr['width']; $align =& $tempAr['align'];
         print $html->tab(2) . '<th align="'.$align.'" width="'.$width.'">'.$tempAr['text'].'</td>' . n();
      }
      ##############################################################
      $tempAr =& $presentationAr['coloumns']['filemtime'];
      if ($tempAr['allow']) {
         $width =& $tempAr['width']; $align =& $tempAr['align'];
         print $html->tab(2) . '<th align="'.$align.'" width="'.$width.'">'.$tempAr['text'].'</td>' . n();
      }
      ##############################################################
      $tempAr =& $presentationAr['coloumns']['description'];
      if ($tempAr['allow']) {
         $width =& $tempAr['width']; $align =& $tempAr['align'];
         print $html->tab(2) . '<th align="'.$align.'" width="'.$width.'">'.$tempAr['text'].'</td>' . n();
      }
      ##############################################################
      $tempAr =& $presentationAr['coloumns']['basket'];
      if ($tempAr['allow']) {
         $width =& $tempAr['width']; $align =& $tempAr['align'];
         print $html->tab(2) . '<th align="'.$align.'" width="'.$width.'">'.$tempAr['text'].'</td>' . n();
      }
      ##############################################################

      print $html->tab(1) . '</tr>' . n();
   }

} // end of class Control

// input:  a filename with or without a local path
// output: a URL of this file (http://host/) is added
function add_http_server_prefix($dir_unit_encoded)
{
   global $_SERVER, $PHP_SELF;
   $server = preg_replace("/\/$/","",$_SERVER['HTTP_HOST']);
   $item = "http://".$server.dirname($PHP_SELF)."/".$dir_unit_encoded;
   return preg_replace("/\.\//","",$item);         // remove ./
}

// if a dir/file-name contains + or / signs it needs to be URL-encoded in a tricky way
function get_unit_encoded($unit)
{
   $unit = urlencode($unit);
   $unit = preg_replace("/%2[fF]/","/",$unit);      // put /-sign back
   return preg_replace("/\+/","%20",$unit);         // change + to %20
}

function branch()
{
// start: plugin check
   if ($GLOBALS['plugin']) {
      call_appropriate_plugin();
      exit;
   }
// end:   plugin check
// start: call sitemap drawer
   if ($GLOBALS['sitemap']) {
      $sitemap = new Sitemap();
      $sitemap->start();
      exit;
   }
// end: call sitemap drawer
// start: call search module
   if ($GLOBALS['search']) {
      $search = new Search();
      $search->start();
      exit;
   }
   if ($GLOBALS['basket']) {
      $basketClass = new Basket(null,$GLOBALS['dir'],null,0);
      $basketClass->call_basket_function($GLOBALS['basket'],$_GET['item']);
   }
// end: call search module
}

function printDirectoryContent()
{
// Sitemap and Search also run until this point, because their dir= parameter
// must be checked too against hacking attempt for instance.
// start: branch
   branch();         // it'll call other functions/classes if the script was called with
                     // modifier parameters, like search=1, sitemap=1, plugin=1, etc.
// end:   branch

   global $download_list, $FILE_NAME, $dir, $dontShowArray, $descriptionArray, $pregExpression;
   global $presentationAr, $html, $dir;
   global $_GET, $log_click;

   $filesArray = array();
   $dirsArray  = array();
   $handle = @opendir($dir);

   $controlObj   = new Control();

   add_exclusion_file_to_the_dontShowArray($dir);
   while (false !== ($unit = readdir($handle))) 
   { 
      $dir_unit = "$dir/$unit";
      //filtering units that we don't want to display
      if ( $unit != '.' && $unit != '..' && $unit != $FILE_NAME 
           && (empty($dontShowArray) || !in_array($unit, $dontShowArray))
           && @is_readable($dir_unit) && (@is_dir($dir_unit) || @is_file($dir_unit)) 
           && preg_match($pregExpression['enable'],$dir_unit) && !preg_match($pregExpression['disable'],$dir_unit) )
      {
         if (@is_file($dir_unit)) $filesArray[] = $dir_unit;
         $controlObj->add($dir_unit);
      }
   }
   closedir($handle);

# START logging clicks
#       we put it here, because we need the $filesArray, and we needed no HTML output so far,
#       that's why we switched the $download_list variable
   if ($log_click['allow'] && isset($_GET['log_click']))
   {
      make_log($filesArray);
      exit;           // it will exit before, but sure is sure
   }
# END logging clicks

   if ($presentationAr['coloumns']['description']['allow'] == YES) fillDescriptionArray();
   if (!$download_list) $html->print_current_directory_description();

   if (!$download_list) print $html->table_open();
   $controlObj->start();
//   print_r($controlObj->descArray);
   if (!$download_list) print $html->table_close();
}

//this function was copied from http://www.php.net/manual/en/function.natcasesort.php
function sort_array(&$array)
{
   global $presentationAr;

   if ($presentationAr['sortingIgnoreCase'] == NO)
   {
      sort($array);
      return;
   }
   //elseif ($presentationAr['sortingIgnoreCase'] == YES)
      
   $separator="|<>|";
   for($i=0;$i<sizeof($array);$i++) { $array[$i]=strtolower($array[$i]).$separator.$array[$i]; }
   sort($array);
   for($i=0;$i<sizeof($array);$i++) { $this=$array[$i]; $this=explode($separator,$this); $array[$i]=$this[1]; }
   for($i=count($array)-1;$i>0;$i--)
   {
      $str_a = $array[$i];
      $str_b = $array[$i-1];
      $cmp_a = strtolower(substr($str_a,0,strlen($str_a)));
      $cmp_b = strtolower(substr($str_b,0,strlen($str_a)));
      if ($cmp_a==$cmp_b && strlen($str_a)<strlen($str_b))
      {
         $array[$i]=$str_b; $array[$i-1]=$str_a; $i+=2;
      }
   }
}

function plugin_selector($img_src_in_html,$file_url,$file_name,$ext)
{
   global $_SERVER, $pluginsArray, $dir, $pluginWindowSizeArray;

   $dimensions = "".$pluginWindowSizeArray['width'].",".$pluginWindowSizeArray['height'];

   if (!empty($ext))
   {
      reset($pluginsArray);
      while ( list($key, $valueArray) = each($pluginsArray) )
      {
         foreach ($valueArray as $value)
         {
            if (case_check($value) == case_check($ext))
            {
               $url  = urlencode($file_url);
               $dir_path = dirname(preg_replace("/(\\\)+/","/",$_SERVER["PATH_TRANSLATED"]));
               $current_dir  = urlencode(preg_replace("/\.\//","/",$dir_path.(strcmp($dir,".")?"$dir":"")));
               $file = $file_name;
               return "<a href=\"javascript: open_plugin_win('$key?url=$url&dir=$current_dir&file=$file',$dimensions)\">$img_src_in_html</a>";
            }
         }
      }
   }
   
   return $img_src_in_html;
}

function plugin_selector_2($img_src_in_html,$file_url,$file_name,$ext)
{
   global $_SERVER, $pluginsArray, $dir, $pluginWindowSizeArray;
   global $PHP_SELF;

   $dimensions = "".$pluginWindowSizeArray['width'].",".$pluginWindowSizeArray['height'];

   if (!empty($ext))
   {
      $plugin_to_call = get_plugin_to_call($ext);
      if ($plugin_to_call != null)
      {
         $url  = urlencode(urlencode($file_url));
         $dir_path = dirname(preg_replace("/(\\\)+/","/",$_SERVER["PATH_TRANSLATED"]));
//         $current_dir  = urlencode(preg_replace("/\.\//","/",$dir_path.(strcmp($dir,".")?"$dir":"")));
         $current_dir  = urlencode(urlencode($dir));
         $file = $file_name;
         return "<a href=\"javascript: open_plugin_win('$PHP_SELF?url=$url&dir=$current_dir&file=$file&plugin=1',$dimensions)\">$img_src_in_html</a>";
      }
   }
   return $img_src_in_html;
}

function get_plugin_to_call($ext)
{
   global $pluginsArray;

   foreach ($pluginsArray as $key => $valueArray)
      foreach ($valueArray as $value)
         if (case_check($value) == case_check($ext)) return $key;
   return null;
}

// it reads the content of the description file to the array $descriptionArray
function fillDescriptionArray()
{
   global $currentDirDescription, $presentationAr, $dir;
   
   $currentDirDescription = "";
   $firstLine = 1;
   $piecesArray = array();
   $fd = @fopen($dir.'/'.$presentationAr['coloumns']['description']['filename'], "r");
   if (!$fd) return;
   while ($buffer = fgets($fd,4096))
   {
      trim($buffer);
      $buffer = perl_chomp($buffer);
      if (strlen($buffer)==0)          continue;    // skip empty lines
      if (preg_match("/^#/",$buffer))  continue;    // skip comment lines
      if ($firstLine)   // the first valuable line
      {
         // if it doesn't contain a ";" sign => this is the description of the current dir.
         if (!preg_match("/;/",$buffer)) $currentDirDescription = $buffer;
         else
         {
            add_to_descriptionArray($buffer);
         }
         $firstLine = 0;
      }
      else // descriptions of directories and files
      {
         add_to_descriptionArray($buffer);
      }
   }
   fclose($fd);
}

// it'll add the element to the array actually
function add_to_descriptionArray($buffer)
{
   global $descriptionArray;
   
   $piecesArray = explode(";",$buffer);
//   if ( $descriptionArray[$piecesArray[0]] == SPACE && strlen($piecesArray[1])>0 )
   $descriptionArray[$piecesArray[0]] = $piecesArray[1];
}

// it reads the content of $exclusion_file and adds them to $dontShowArray
function add_exclusion_file_to_the_dontShowArray($dir)
{
   global $dontShowArray;
   
   $dontShowArray = array_merge($dontShowArray, get_excluded_units($dir));
}

// read the content of the exclusion file (its default name is traverse.ex)
// and give it back as an array
function get_excluded_units($dir)
{
   global $exclusion_file;

   $collectArray = array();
   $fd = @fopen("$dir/$exclusion_file", "r");
   if (!$fd) return;
   while ($buffer = fgets($fd,4096))
   {
      trim($buffer);
      $buffer = perl_chomp($buffer);
      if (strlen($buffer)==0)          continue;    // skip empty lines
      if (preg_match("/^#/",$buffer))  continue;    // skip comment lines
      $collectArray[] = $buffer;
   }
   fclose($fd);
   return $collectArray;
}

// not used any more
function dots($name, $size) {
   global $presentationAr;
   return $presentationAr['max_width'] - strlen($name) - strlen($size);
}

// converts the filesize (number) into a more readable string
function file_size_to_str($size)
{
   global $presentationAr;

   $result = '[' . SPACE;
   $byte_s = SPACE . 'byte' . ($size>1 ? 's' : '');
   switch ($presentationAr['filesize_style'])
   {
      case PRETTY:
         $byte_s = '';
         // goes on in case PRETTY_BYTE:
      case PRETTY_BYTE:
         $str = "$size";
         $str = strrev($str);
         for ($i=0; $i<strlen($str); ++$i)
         {
            if ($i%3==0 && $i!=0) $new_str.=',';
            $new_str.=$str[$i];
         }
         $result .= ( strrev($new_str) . $byte_s );
         break;
      case KB_MB_GB:
         $KB = 1024; $MB = 1024 * $KB; $GB = 1024 * $MB; 
         if     ($size >= $GB)   $size = round($size / $GB * 100) / 100 . ' Gb';
         elseif ($size >= $MB)   $size = round($size / $MB * 100) / 100 . ' Mb';
         elseif ($size >= $KB)   $size = round($size / $KB * 100) / 100 . ' Kb';
         else                     $size = $size . $byte_s;
         $result .= $size;
         break;
      case BYTE:
      default:
         $result .= $size;
         break;
   }
   return ( $result .= (SPACE.']') );
}

// if password protection is switched on it'll check the session
// completely rewritten in v0.7.0
function check_password()
{
   global $password, $dir;
   global $passwordAr;
   global $meta_informationAr, $html;
   global $_POST,$cwd;
   
   // in the case of optional password protection the password file must be searched for
   // in the current directory!
   // if the password protection is always ON, the place of the password file is fix
   $password_file = ( ($passwordAr['allow'] == OPTIONAL) 
                        ? ( $dir . '/' . $passwordAr['filename'] )
                        : $passwordAr['filename'] );
   
   // if protection is off, we have nothing to do here
   if ($passwordAr['allow'] == OFF) return; 
   // if pwd protection is ON and the user has already given once the correct password
   if (($passwordAr['allow'] == ON) && (isset($_SESSION['phptraverse_password']))) return;
   // if pwd protection is OPTIONAL and the user has already given once the correct password _for this dir_
   if (($passwordAr['allow'] == OPTIONAL) && (isset($_SESSION["$cwd"])))           return;
   // else

   if ($passwordAr['allow'] == OPTIONAL)   
   {
      if (!file_exists(realpath($password_file))) return;   // if the password file not exists => nothing to do
      // else, if exists but
      if (!is_readable($password_file))
      {
         my_die("Password protection is switched on in this directory, but the password file is not readable.<br />".
                "Tip: check if the rights of the file are correct.");
         exit;      // sure is sure
      }
   }
   // else
   // we get here if password protection is ON _or_ if it's optional AND 
   // (passwd file exists AND readable) 
   // to sum up: we need the password from the user now!
   
   $buffer = @file($password_file);
   $buffer = perl_chomp($buffer[0]);
   $password_field = $_POST['phptraverser_password_field'];
   if (!empty($password_field))
   {
      $traverse_password = $password_field;
   }
   if (!isset($password_field))
   {
      $html->print_start_html("Ooops :)");
      print '<font class="tgtext">' . $meta_informationAr['title'] . '</font>' . "\n";
      print_password_form();
      my_exit();
   }

   // if the password is correct
   if( md5($traverse_password) == $buffer ) 
   {
      if ($passwordAr['allow'] == ON)           $_SESSION['phptraverse_password'] = 1;
      elseif ($passwordAr['allow'] == OPTIONAL) $_SESSION["$cwd"] = 1;
   }
   else  // if the password is not correct
   {
      $html->print_start_html("Ooops :)");
      print '<font class="tgtext">' . $meta_informationAr['title'] . '</font>' . "\n";
      print "<p>Wrong password! Try again!</p>\n";
      print_password_form();
      my_exit();
   }
}

function print_password_form()
{
   global $PHP_SELF, $dir, $passwordAr;

   $type = ($passwordAr['show'] ? 'text' : 'password');

// in a hidden field we pass the value of $dir, so if the code was correct,
// we'll get to this given directory immediately
   print <<< END
<p>
<form action="$PHP_SELF" method="POST">
   <font class="tgtext">Password: </font>
   <input type=$type name="phptraverser_password_field">
   <input type="hidden" name="dir" value="$dir">
   <input type="submit" value="Maybe">
</form>
</p>

END;
}

function getDirFromQueryString($QS) {
   if (preg_match("/dir=(.*)&download_list=(.*)/",$QS,$matches))
      return (urldecode($matches[1]));
}

//gets the value of $download_list from the GET query string
function getValue($download_list)
{
   global $_GET;
   
   if (!isset($download_list))
   {
      if (!isset($_GET['download_list'])) $download_list=0;
      else                                 $download_list=1;
   }
   if (empty($download_list)) $download_list=0;
   return $download_list;
}

//checks the $dir parameter in the GET query string
function checkParameterDirectory()
{
   global $dir, $_GET;
   
   //if a subdir. was protected, a hidden field gives the value of the dir., this
   //way after giving the password we'll get immediately to the protected dir.
   if (isset($_POST['dir'])) $dir = $_POST['dir'];

   //the following security patch was sent by Ly0n. Thanks for that.
   if (!isset($dir))
   {
      if(!isset($_GET['dir']))    $dir=".";
      else                         $dir = $_GET['dir'];
   }
   if (empty($dir)) $dir=".";
   
   if (!($dir{0} == '.' && stristr($dir, '..') == false))
   {
      my_die('hacking attempt');
   }

   if(!is_dir($dir))
   {
      my_die("$dir is not a valid directory");
   }

   $handle = @opendir($dir);
   if(!$handle)
   {
      my_die("cannot open the directory $dir");
   }
}

function my_die($msg)
{
   global $meta_informationAr, $html;

   $title = $meta_informationAr['title'];
   
   $html->print_start_html("Ooops :)");
   print <<<END
<font class="tgtext">$title</font>
<p><font color="red"><b>Error:</b> </font>$msg!</p>

END;
   my_exit();
}

// newline, in HTML style, <br /> is XHTML conform
function nl() { return "<br />\n"; }
// just a "\n", for the nice html source
function n()  { return "\n"; }

//first close the HTML page then exit
function my_exit()
{
   global $html;

   $html->print_end_html();
   exit();
}

function get_print_title($showVersion) 
{
   global $meta_informationAr;

   $title = $meta_informationAr['title'];
   if ($showVersion==1) $version = ' ' . $meta_informationAr['version'];
   else                  $version = '';

   return '<font class="tgtitle">'.$title.$version.'</font>';
}

//prints the current working directory
function get_print_current_dir() {
   global $cwd;
   return '<font class="tgtext">current dir: '.$cwd.'/'.'</font>';
}

//prints a fast-jump thingie
function get_print_fast_jump() {
   global $PHP_SELF, $dir;
   
   foreach (explode("/",$dir) as $value) $dirArray[] = $value;
   
   for ($i=0, $size=count($dirArray); $i<$size; ++$i)
   {
      $value_short = $dirArray[$i];
      
      if ($i)    $value_full .= "/";
      $value_full .= $value_short;

      if ($i) $fast_jump .= " / ";
      $fast_jump .= "<a href=\"$PHP_SELF?dir=".urlencode($value_full)."\">$value_short</a>";
   }
   return '<font class="tgtext">fast-jump: '.$fast_jump.'</font>';
}

function get_print_search()
{
   global $PHP_SELF, $dir, $searchAr;

   if ($searchAr['allow'])
   {
      $js_open = "javascript: open_search_win('"; $js_close = "')";
//      return '<a style="text-decoration:none" href="'.$js_open.$PHP_SELF.'?dir='.urlencode(urlencode($dir)).'&search=1'.$js_close.'"><input type="button" value="Search"></a>';
      return '[ <a href="'.$js_open.$PHP_SELF.'?dir='.urlencode(urlencode($dir)).'&search=1'.$js_close.'">'.
             'Search</a> ]';
   }
   else return '';
}

function get_print_manage_basket()
{
   global $basketAr;
   if ($basketAr['allow'] == false) return '';
   // else
   $BasketClass = new Basket(null,$GLOBALS['dir'],null,0);
   $manage_link  = $BasketClass->get_print_manage_basket();
   clearstatcache();
   $text = $basketAr['text']; $size = count($_SESSION['basketArray']);
   return '[ <a href="'.$manage_link.'">'.$text." ($size)".'</a> ]';
}

function get_print_add_to_basket($item)
{
   global $presentationAr;
   $link_text = $presentationAr['coloumns']['basket']['link_text'];
   $BasketClass = new Basket(null,$GLOBALS['dir'],null,0);
   $link  = $BasketClass->get_print_add_to_basket($item);
   return '[ <a href="'.$link.'">'.$link_text.'</a> ]';
}

function get_print_sitemap()
{
   global $sitemapAr;
   if ($sitemapAr['allow'])
   {
      global $PHP_SELF, $dir;
      return ''.
      '<form name="sitemap" action="'.$PHP_SELF.'" method="GET">'.
      '   <input type="hidden" name="dir" value="'.$dir.'">'.
      '   <input type="hidden" name="sitemap" value="1">'.
      '   <input type="submit" value="GraphViz Sitemap">'.
      '</form>';
//      return '<a style="text-decoration:none" href="'.$PHP_SELF.'?dir='.urlencode($dir).'&sitemap=1'.'"><input type="button" value="GraphViz Sitemap"></a>';
//      return '<form>'.
//             '<input style="text-decoration:none" type="button" value="GraphViz Sitemap" onSubmit="self.location='.$PHP_SELF.'?dir='.urlencode($dir).'&sitemap=1'.'">'.
//             '</form>';
   }
   else return '';
}

// trim() is not enough :( But the documentation says that trim() chops "\n" too ... bullshit
function perl_chomp($string) {
   $string = preg_replace("/\r/","",$string);      // because of Windows
   return preg_replace("/\n/","",$string);
}

// it should be implemented :) It would get $BASE and it would create the value
// of $BASE_URL
// At the moment the user has to give both values :(
function getBASE_URL($absolute_path)
{
}

function case_check($str)
{
   global $presentationAr;

   if ($presentationAr['ignoreCase'] == 0)    return $str;
   else                                        return strtolower($str);
}

function make_log_check($file)
{
   // if someone tries to get another file with a changed GET query string
   if (!($file{0} == '.' && stristr($file, '..') == false)) {
      my_die('hacking attempt');
   }
   // is it a file at all?
   if(!is_file(urldecode($file))) {
      my_die("$file is not a valid file");
   }
   // is it a readable file?
   if (!is_readable(urldecode($file))) {
      my_die("cannot read the file $file");
   }
}

function make_log($filesWithRelativePathArray)
{
   global $_GET, $dir, $log_click;

   $file_with_path_to_log = $file_to_log = $_GET['log_click'];      // URL-encoded
   $cwd         = $dir;                                 // current dir, where the user clicked
   $log_file    = $cwd . '/' . $log_click['file'];      // the log file
   $filesArray  = array();
   $delimiter   = $log_click['delimiter'];
   $date        = date($log_click['date_format']);
   $logArray    = array();

   make_log_check($file_to_log);
   // if there was something wrong with the parameter, the script STOPS HERE
   // else, if OK

# START removing directories from the file-paths + urldecode the filename to be logged
   foreach ($filesWithRelativePathArray as $value) $filesArray[] = basename($value);
   $file_to_log = basename(urldecode($file_to_log));
# END   removing directories from the file-paths + urldecode the filename to be logged

# START file manipulation
   // for this part I used a message sent to http://fr3.php.net/manual/en/function.fopen.php
   clearstatcache();
   ignore_user_abort(true);     ## prevent refresh from aborting file operations and hosing file
   // if the file is not written, remove the @ for debug purposes
    if (!file_exists($log_file))
   {
      $fp = @fopen($log_file, "a+");      // touch: create the file if it doesn't exist yet
      if ($fp) {                           // if touch was OK: close and open again in read/write mode
         fclose($fp);
         $fp = @fopen($log_file, "r+b");   // reopen in read/write mode (as it doesn't create the file if it didn't exist)
      }
   }
   // if file_exists($log_file)
   else $fp = @fopen($log_file, "r+b");   // reopen in read/write mode

   if ($fp)
   {
      if (flock($fp, LOCK_EX))     ## don't do anything unless lock is successful
      {
         while ($buffer = fgets($fp,4096))
         {
            // read in the log file, fill an array
            $buffer = perl_chomp($buffer);
            $pieces = explode($delimiter, $buffer);
            $logArray[] = array(
               'count' => $pieces[0],
               'file'  => $pieces[1],
               'date'  => $pieces[2]
            );
         }
         // increase the counter of the clicked file
         // 2 cases: already there (increase by one), not there yet (insert with counter 1)
         $found = $i = 0;
         $deleteIndexesArray = array();
         reset($logArray);
         foreach ($logArray as $item) 
         {
            // garbage collection - collect the indexes of the elements to delete
            // if a file in the log is not any more in the file system => delete from the log
            // 1) we look, if the file is visible by the script
            // 2) if not visible it may still be there (for ex. hidden because of its rights),
            //    but if this file doesn't even exists: delete it
            if ($log_click['delete_not_present_files'])            // garbage collection ON?
               if (!in_array($item['file'], $filesArray))         // is this file invisible to the script?
//                  if (!file_exists($cwd . '/' . $item['file']))    // does it not exist any more?
                     $deleteIndexesArray[] = $i;                  // register its index in the array

            if ( strcmp($item['file'], $file_to_log) == 0 )      // if it's there
            {
               $found = 1;
               ++$logArray[$i]['count'];         // as $item is a copy, it'd be in vain to modify the array by that
               $logArray[$i]['date'] = $date;   // update the access time
            }
            ++$i;
         }
         // delete the elements whose indexes were collected before
         // we must do it before changing the size of the array
         foreach ($deleteIndexesArray as $i) unset($logArray[$i]);

         // if it's not there yet, i.e. it was clicked on for the first time
         if (!$found) $logArray[] = array( 'count' => 1, 'file'  => $file_to_log, 'date'  => $date );

         // sort the log in descending order 
         $logArray = array_reverse(multi_sort($logArray, "count"));

         # OK, let's write the modified log array back to the log file
         rewind($fp);
         reset($logArray);
         foreach ($logArray as $item)
         {
            fwrite( $fp, $item['count'].$delimiter.$item['file'].$delimiter.$item['date']."\n" );
         }
         fflush($fp);
         ftruncate($fp, ftell($fp));     ## better than truncating to 0 before writing
         flock($fp, LOCK_UN);
      } // end of: if (flock($fp, LOCK_EX))     ## don't do anything unless lock is successful
      else print "Could not lock the file '$log_file'";
      fclose($fp);
   } // end of: if ($fp)
   else 
   {
      print <<< END
Could not open the file $log_file for read/write operation<br /><br />
<font color="red"><b>Jabba's hint for the administrator of the script:</b></font> make sure that the $log_file is 
readable and writieable by the script (check the rights).<br />
The script tries to log how many times a file has been clicked.
If you do not want this, turn it off in the config file, modifying the log_click array (allow = 0)<br /><br />

END;
#' because of Vim, can be deleted
   }
   ignore_user_abort(false);     ## put things back to normal
# END   file manipulation

   @header("Location: $file_with_path_to_log");   
   exit;
}

# I used here a message from http://www.php.net/manual/en/function.uasort.php
function multi_sort($array, $key)
{
   $cmp_val="((\$a['$key']>\$b['$key'])?1:
      ((\$a['$key']==\$b['$key'])?0:-1))";
   $cmp=create_function('$a, $b', "return $cmp_val;");
   uasort($array, $cmp);
   return $array;
}

// responsible for the graph visualisation
class Sitemap
{
   var $dir;
   var $php_self;
   var $graph;
   var $root_color;
   var $current_color;

   function Sitemap() {
      $this->dir           = $GLOBALS['dir'];
      $this->php_self      = $GLOBALS['PHP_SELF'];
      $this->root_color    = '#cc99cc';
      $this->current_color = '#ccffcc';
   }

   function start() 
   {
      $fontpath = $GLOBALS['SET_FONT']; 
      $send = '';
      if (isset($_GET['get']) && !empty($_GET['get'])) $send = $_GET['get'];

      require_once($GLOBALS['BASE'].'/Image/GraphViz-1.0.1/GraphViz.php');
      $this->graph = new Image_GraphViz(TRUE,array(
         'bgcolor' => 'transparent',
         'rankdir' => 'LR',
      ), $GLOBALS['DOT_PATH'], $GLOBALS['NEATO_PATH'], $GLOBALS['TMP_DIR']);
      $this->graph->add_directly(array(
         ( !empty($fontpath)
            ? 'node [shape=box, height=.1, width=.1, fontname="'.$fontpath.'", fontsize=10];'
            : 'node [shape=box, height=.1, width=.1, fontsize=9];'),
         'edge [arrowhead=none, headport="w", tailport="e"];'
      ));
      $this->add_to_dot_graph('.');
      $this->traverse('.');
      //
      $cmap = $this->graph->get_cmap();

      if ($send == 'img') $this->graph->get_image('gif');
      else 
      {
         $encoded_dir = urlencode($this->dir);
         $php_self = $this->php_self;
         $base_url = $GLOBALS['BASE_URL'];
         print <<< END
<html>
<head>
   <title>Dynamic GraphViz Sitemap module for Jabba''s PHP Traverser</title>
   <meta name="author" content="Laszlo Szathmary, alias Jabba">
   <meta name="title"  content="Dynamic GraphViz Sitemap">
   <link rel="stylesheet" type="text/css" href="$base_url/css_js/stylesheet_sitemap.css">
</head>
<body>
<table border="0" width="100%">
<tr>
<td align="left">[ <a href="javascript: history.go(-1)">b a c k</a> ]</td>
<td align="right">[ <a href="javascript: history.go(-1)">b a c k</a> ]</td>
</tr>
<tr><td colspan="2" align="center"><img src="$php_self?dir=$encoded_dir&sitemap=1&get=img" usemap="#imagemap" ismap border="0"></td></tr>
<tr>
<td align="left">[ <a href="javascript: history.go(-1)">b a c k</a> ]</td>
<td align="right">[ <a href="javascript: history.go(-1)">b a c k</a> ]</td>
</table>
<map name="imagemap">
$cmap
</map>
</body>
</html>

END;
//      print $this->graph->get_source();       // for testing
      }
   }

   function add_to_dot_graph($dir)
   {
      if ($dir == '.')
      {
         $server = preg_replace("/\/$/","",$_SERVER['HTTP_HOST']);
         $this->graph->addNode('.', array('label' => 'http://'.$server.$this->php_self,
                                    'fillcolor' => $this->root_color,
                                    'style' => 'filled',
                                    'URL' => $this->php_self));
      }
      else
      {
         $parent = dirname($dir);
         if ($this->dir == $dir) 
         {   // change color, "You are here"
            $this->graph->addNode($dir, array('label' => basename($dir),
                                              'fillcolor' => $this->current_color,
                                              'style' => 'filled',
                                              'shape' => 'octagon',
                                              'URL' => $this->php_self.'?dir='.urlencode($dir)));
         }
         else 
         {
            $this->graph->addNode($dir, array('URL' => $this->php_self.'?dir='.urlencode($dir),
                                              'label' => basename($dir)));
         }
         $this->graph->addEdge(array($parent => $dir));
      }
   }

   // recursive traversing, it'll add each dir to the graph
   function traverse($loc)
   {
      global $pregExpression, $dontShowArray;

      $excludedUnitsArray = get_excluded_units($loc);
      $d = dir($loc);
      while (false !== ($unit = $d->read())) 
      {
         $dir_unit = $d->path.'/'.$unit;       // this below is a trick: if the array is empty, in_array() drops an error message about the 2nd argument
         if ( $unit != '.' && $unit != '..'
              && (empty($dontShowArray) || !in_array($unit, $dontShowArray))
              && (empty($excludedUnitsArray) || !in_array($unit,$excludedUnitsArray))
              && @is_readable($dir_unit) && @is_dir($dir_unit)
              && preg_match($pregExpression['enable'],$dir_unit) && !preg_match($pregExpression['disable'],$dir_unit) )
         {
            $this->add_to_dot_graph($dir_unit);    // add dir to the graph
            $this->traverse($dir_unit);            // continue
         }
      }
      $d->close();
   }
}

// responsible for the search extension
class Search
{
   var $dir;
   var $php_self;
   var $type;
   var $base_url;
   var $self_link;
   var $select;
   var $input;
   var $collectArray;
   var $search_download;
   var $dl_type;

   function Search()
   {
      global $searchAr;

      $this->dir              = $GLOBALS['dir'];
      $this->php_self         = $GLOBALS['PHP_SELF'];
      $this->type             = $searchAr['type']; 
      if (isset($_GET['type']) && !empty($_GET['type']))       $this->type = $_GET['type'];
      $this->base_url         = $GLOBALS['BASE_URL'];
      $this->self_link        = $this->php_self.'?dir='.urlencode($this->dir).'&search=1';
      $this->select           = '';
      if (isset($_GET['select']) && !empty($_GET['select']))   $this->select = $_GET['select'];
      $this->input            = '';
      if (isset($_GET['input']) && !empty($_GET['input']))     $this->input = stripslashes($_GET['input']);
      $this->collectArray     = array();
      $this->search_download  = 0;
      if (isset($_GET['search_download']) && !empty($_GET['search_download']))   $this->search_download = $_GET['search_download'];
      $this->dl_type          = '';
      if (isset($_GET['dl_type']) && !empty($_GET['dl_type']))   $this->dl_type = $_GET['dl_type'];
   }

   // the main function, it'll call all the others
   function start()
   {
//      global $html;
      if (!$this->search_download) $this->print_start_html();
      if (!$this->search_download) $this->print_search_form();
      $this->search_controller();
      if (!$this->search_download) $this->print_end_html();
//      if (!$this->search_download) $html->print_end_html();
   }
   
   // print the search form - either the basic one or the advanced
   function print_search_form()
   {
      global $searchAr;

      $dir        = $this->dir;
      $php_self   = $this->php_self;
      $type       = $this->type;
      $input      = $this->input;
      $download_button = '';
      $show_current_dir_button = '';
      if ($searchAr['showDownloadButtons']) 
      {
         $query_string =   $this->php_self.
                           '?dir='.urlencode(urlencode($this->dir)).
                           '&search=1'.
                           '&type='.$this->type.
                           '&select='.$this->select.
                           '&input='.$this->input.
                           '&search_download=1';
         $download_button .= $this->get_download_button(DL_ALL,          $query_string);
         $download_button .= $this->get_download_button(DL_CURRENT_DIR,  $query_string);
      }
      if ($searchAr['showShowCurrentDir']) $show_current_dir_button .= $this->get_show_current_dir_button($this->dir);

      print <<< END
<p>
<form name="search_form" method="GET" action="$php_self">
<input type="hidden" name="dir"    value="$dir">
<input type="hidden" name="search" value="1">
<input type="hidden" name="type"   value="$type">
END;
      switch ($type)
      {
         case BASIC: print <<< END
Unit name
<select name="select" size="1">
   <option selected>contains</option>
   <option>is</option>
</select>:<br />
END;
            break;
         case ADVANCED: print <<< END
Case 
<select name="select" size="1">
   <option selected>insensitive</option>
   <option>sensitive</option>
</select> search:<br />
END;
            break;
         default: 
            break;
      }
      print <<< END
<input type="text" size="50" name="input" value="$input"><br />
<input type="submit" value="Search">
<input type="button" value="Reset" onclick="document.forms.search_form.input.value=''">
<p><font size="-1">$download_button $show_current_dir_button</font>
</form>
END;
   }

   function get_download_button($dl_type, $query_string)
   {
      global $searchAr;
      static $js_open = "javascript: open_download_list_win('", $js_close = "')";
      return '[ <a class="help" href="'.$js_open.$query_string.'&dl_type='.$dl_type.$js_close.'">'.
             $searchAr[$dl_type].'</a> ]';
   }

   function get_show_current_dir_button($dir)
   {
      global $searchAr;
      $js_open   = "javascript: open_in_parent('"; $js_close = "')";
      $a_open    = '[ <a class="help" href="';
      $a_mid     = $this->php_self.'?dir='.urlencode(urlencode($dir)).$js_close.'">';
      $a_close   = '</a> ]';
      return $a_open.$js_open.$a_mid.$searchAr['showCurrentDirText'].$a_close;
   }

   function print_start_html()
   {
      global $searchAr;
      $type       = $this->type;
      $base_url    = $this->base_url;
      $other = ($type == BASIC) ? ADVANCED : BASIC;
      $other_link = '<a href="'.$this->self_link.'&type='.$other.'">'.$other.'</a>';

      print <<< END
<html>
<head>
   <title>Search module for Jabba''s PHP Traverser</title>
   <meta name="author" content="Laszlo Szathmary, alias Jabba">
   <meta name="title"  content="Search module">
   <link rel="stylesheet" type="text/css" href="$base_url/css_js/stylesheet_search.css">
   <script language="JavaScript" src="$base_url/css_js/open_win.js"></script>
</head>
<body onload="document.forms.search_form.input.focus()">
<table border="0" width="99%">
<tr><td align="left"><font class="tgtitle">$type Search</font></td>
    <td align="right">[&nbsp;<a class="help" href="javascript: open_help_win('$base_url/search/help.php#$type')">Help</a>&nbsp;]</td>
</tr>
<tr><td align="left">Change to $other_link search.</td></tr>
</table>

END;
   }

   function print_end_html()
   {
      print <<< END
</body>
</html>

END;
   }

   // control the search: start it, then print it
   function search_controller()
   {
      if (empty($this->input)) return;
      // else
      $this->traverse($this->dir);
      if (!$this->search_download)  $this->print_found_items();
      else                          $this->print_search_download_list($this->dl_type);
   }

   // traverse recursively from the given directory
   function traverse($loc)
   {
      global $pregExpression, $dontShowArray;
      
      $excludedUnitsArray = get_excluded_units($loc);
      $dirArray = array();
      $d = dir($loc);
      while (false !== ($unit = $d->read())) 
      {
         $dir_unit = $d->path.'/'.$unit;       // this below is a trick: if the array is empty, in_array() drops an error message about the 2nd argument
         if ( $unit != '.' && $unit != '..' 
              && (empty($dontShowArray) || !in_array($unit, $dontShowArray))
              && (empty($excludedUnitsArray) || !in_array($unit,$excludedUnitsArray))
              && @is_readable($dir_unit) && (@is_dir($dir_unit) || @is_file($dir_unit)) 
              && preg_match($pregExpression['enable'],$dir_unit) && !preg_match($pregExpression['disable'],$dir_unit) )
         {
            // if the search criteria matches this file/dir => add it
            if ($this->search_ok($unit)) $this->add_to_collect_array($d->path, $unit, $dir_unit);
            if (@is_dir($dir_unit)) $dirArray[] = $dir_unit;
         }
      }
      $d->close();
      foreach ($dirArray as $dir) $this->traverse($dir);
      unset($dirArray);
   }

   // checks if the search criteria is true on this dir/file-name
   function search_ok($unit)
   {
      if ($this->type == BASIC)
      {
         switch ($this->select) {
            case 'contains':
               return stristr($unit, $this->input);
               break;
            case 'is':
               return ($unit == $this->input);
               break;
            default:
               break;
         }
      }
      else // if ($this->type == ADVANCED)
      {
         switch ($this->select) {
            case 'insensitive':
               return @preg_match('/'.$this->input.'/i', $unit);
               break;
            case 'sensitive':
               return @preg_match('/'.$this->input.'/', $unit);
               break;
            default:
               break;
         }
      }
   }

   // it'll add the dir/file-name to an array (first we collect everything in an array, then it's easier
   // to work with the array)
   // the array structure: an array of directory names, and each of these elements point
   // to an array of files
   function add_to_collect_array($path, $unit, $dir_unit)
   {
      $array =& $this->collectArray;
      if (@is_dir($dir_unit)) {
         if (!isset($array[$path])) $array[$dir_unit] = array();
      }
      else   // if (@is_file($dir_unit))
      {
         if (!isset($array[$path])) $array[$path] = array();
         $this->collectArray[$path][] = $unit;
      }
   }

   // print 'em in the browser (two cases: dir or file)
   function print_found_items()
   {
      if ( isset($this->input) && !empty($this->input) && empty($this->collectArray)) 
      { 
         print("No items found."); 
         return; 
      }
      // else

      print '<table border="0" width="100%">'."\n";
      foreach ($this->collectArray as $dirName => $array)
      {
         $this->print_dir($dirName);
         $this->print_file($dirName, $array);
      }
      print '</table>'."\n";
   }

   // if the "get download list" button was pressed: print only the files
   function print_search_download_list($dl_type)
   {
      header('Content-type: text/plain');

      if ($dl_type == DL_ALL)
         foreach ($this->collectArray as $dirName => $array)
         {
            foreach ($array as $file)
               print add_http_server_prefix(get_unit_encoded($dirName.'/'.$file))."\n"; 
         }
      else // if ($dl_type == DL_CURRENT_DIR)
      {
         $refArray =& $this->collectArray[$this->dir];
         if (isset($refArray))
            foreach ($refArray as $file)
               print add_http_server_prefix(get_unit_encoded($this->dir.'/'.$file))."\n"; 
      }
   }

   // print the name of a dir and put a link on this
   function print_dir($dirName)
   {
      print '   <tr><td colspan="2">'.$this->dir_link($dirName).'</td></tr>'.n();
   }

   // create a link on the dir-name. If clicked, it'll be opened in the parent window.
   function dir_link($dir)
   {
      static $js_open   = "javascript: open_in_parent('", $js_close = "')";
      static $a_open    = '<a class="dir" href="';
             $a_mid     = $this->php_self.'?dir='.urlencode(urlencode($dir)).$js_close.'">';
      static $a_close   = '</a>';
      return $a_open.$js_open.$a_mid.$dir.$a_close;
   }

   // print the name of files and put a link on them
   function print_file($dirName, $array)
   {
      $file_link_start = '';
      $file_link_end = '';
      print '   <tr><td width="10%">&nbsp;</td><td width="*">';
      for ($i=0, $max = count($array); $i<$max; ++$i)
         $this->print_file_link($dirName, $array[$i], $i<$max-1);
      print '</td></tr>'.n();
   }

   // create a link on the file-name. If clicked, it'll be opened in the parent window.
   function print_file_link($dir, $file, $comma)
   {
      $unit_encoded = get_unit_encoded($dir . '/' . $file);
      static $js_open   = "javascript: open_in_parent('", $js_close = "')";
      static $a_open    = '<a class="file" href="';
             $a_mid     = $unit_encoded.$js_close.'">';
      static $a_close   = '</a>';
      print  $a_open.$js_open.$a_mid.$file.$a_close.($comma?', ':'');
   }
} // end of class Search

function call_appropriate_plugin()
{
   global $_GET, $PHP_SELF;

   $url     = $_GET['url'];
   $dir     = $_GET['dir'];
   $file    = $_GET['file'];
   $call_link = $PHP_SELF.'?url='.$url.'&dir='.$current_dir.'&plugin=1';
   
   $plugin = get_plugin_to_call(DescFile::getExtension($file));
//   print $plugin;
   include_once($plugin);
   $class  = new Plugin($url, $dir, $file);
   $class->start();
}

function get_readable_items_array($loc)
{
   global $pregExpression, $dontShowArray;

   $collectArray = array();
   $excludedUnitsArray = get_excluded_units($loc);
   $d = dir($loc);
   while (false !== ($unit = $d->read())) 
   {
      $dir_unit = $d->path.'/'.$unit;       // this below is a trick: if the array is empty, in_array() drops an error message about the 2nd argument
      if ( $unit != '.' && $unit != '..'
           && (empty($dontShowArray) || !in_array($unit, $dontShowArray))
           && (empty($excludedUnitsArray) || !in_array($unit,$excludedUnitsArray))
           && @is_readable($dir_unit) && (@is_file($dir_unit) || @is_dir($dir_unit))
           && preg_match($pregExpression['enable'],$dir_unit) && !preg_match($pregExpression['disable'],$dir_unit) )
      {
         $collectArray[] = $dir_unit;
      }
   }
   $d->close();

   return $collectArray;
}

function getFilesFromArray($array, $chopDirPrefix = 1)
{
   $collectArray = array();
   foreach ($array as $value) 
      if (is_file($value)) 
         $collectArray[] = ($chopDirPrefix ? basename($value) : $value);
   return $collectArray;
}

function getDirsFromArray($array, $chopDirPrefix = 1)
{
   $collectArray = array();
   foreach ($array as $value) 
      if (is_dir($value)) 
         $collectArray[] = ($chopDirPrefix ? basename($value) : $value);
   return $collectArray;
}

class Basket
{
   var $self_link;
   var $self_link_for_javascript;

   function Basket($url, $dir, $file, $plugin = 1)
   {
      global $PHP_SELF;
      @session_start();
      if (!isset($_SESSION['basketArray']))
         $_SESSION['basketArray'] = array();
      $this->self_link = $PHP_SELF.
                         '?url='.urlencode($url).
                         '&dir='.urlencode($dir).
                         '&file='.urlencode($file);
      if ($plugin) $this->self_link .= '&plugin=1';
      $this->self_link_for_javascript = $PHP_SELF.
                                        '?url='.urlencode(urlencode($url)).
                                        '&dir='.urlencode(urlencode($dir)).
                                        '&file='.urlencode(urlencode($file));
      if ($plugin) $this->self_link_for_javascript .= '&plugin=1';
   }

   function print_javascript_and_css_include_files($stylesheet)
   {
      $base_url = $GLOBALS['BASE_URL'];
      print <<< END
      <link rel="stylesheet" type="text/css" href="$stylesheet">
      <script language="JavaScript" src="$base_url/css_js/open_win.js"></script>

END;
   }
   function print_start_html()
   {
      $base_url = $GLOBALS['BASE_URL'];
      print '<html><head>'.n();
      $this->print_javascript_and_css_include_files($base_url.'/css_js/stylesheet_mp3_id.css').
      print '</head><body>'.n();
   }
   function print_end_html()
   {
      print <<< END
      </body>
      </html>

END;
   }

   function print_basket_bar($url, $file)
   {
      $item    = $url.'/'.$file;
      $add_link     = $this->get_print_add_to_basket($item);
      $remove_link  = $this->get_print_remove_from_basket($item);
      $get_link     = $this->get_print_get_basket_list();
      $manage_link  = $this->get_print_manage_basket();
      print <<< END
      [ <a href="$add_link">Add</a> ] [ <a href="$remove_link">Remove</a> ] 
      [ <a href="$get_link">Get List</a> ] [ <a href="$manage_link">Manage List</a> ]<br />

END;
   }

   function get_print_add_to_basket($item) {
      return $this->self_link.'&basket='.ADD_BASKET.'&item='.urlencode($item);
   }
   function add_to_basket($item) {
      $_SESSION['basketArray'][$item] = 1;
   }

   function get_print_remove_from_basket($item) {
      return $this->self_link.'&basket='.REMOVE_BASKET.'&item='.urlencode($item);
   }
   function remove_from_basket($item) {
      unset($_SESSION['basketArray'][$item]);
   }

   function get_print_manage_basket()
   {
      $js_open = "javascript: open_basket_win('"; $js_close = "')";
      return $js_open.$this->self_link_for_javascript.'&basket='.MANAGE_BASKET.$js_close;
   }
   function get_print_get_basket_list()
   {
      $js_open = "javascript: open_download_list_win('"; $js_close = "')";
      return $js_open.$this->self_link_for_javascript.'&basket='.GET_BASKET.$js_close;
   }
   function manage_remove_basket($item)
   {
      $this->remove_from_basket($item);
      $this->manage_basket();
   }
   function manage_basket()
   {
      global $html;
      $array = $_SESSION['basketArray'];

      if (!isset($_GET['plugin'])) $this->print_start_html();
      print '<center><font class="tgtitle">Items in your basket</font></center><p>'.nl();
      print '<table border="1" bordercolor="#000000" width="80%" align="center">'.n();
      foreach (array_keys($array) as $item)
      {
         $manage_remove_link  = $this->self_link.'&basket='.MANAGE_REMOVE_BASKET.'&item='.urlencode($item);
         $item_formatted = $this->format($item);
         print <<< END
         <tr>
            <td class="tgurl"><a href="$item">$item_formatted</a></td>
            <td align="center"><a href="$manage_remove_link">Delete</a></td>
         </tr>

END;
      }
      print '</table>'.n();
      $get_link     = $this->get_print_get_basket_list();
      print <<< END
      <p>
      [ <a href="$get_link">Get Download List</a> ]

END;
      $html->print_end_html(false);
      exit;
   }
   function get_basket_list()
   {
      header('Content-type: text/plain');
      foreach (array_keys($_SESSION['basketArray']) as $item)
         print $item."\n";
      exit;
   }

   function format($url) {
      return dirname($url).'/'.'<b>'.basename($url).'</b>';
   }

   function call_basket_function($basket_call_type, $item)
   {
      switch ($basket_call_type) {
         case ADD_BASKET:              $this->add_to_basket($item);        break;
         case REMOVE_BASKET:           $this->remove_from_basket($item);   break;
         case GET_BASKET:              $this->get_basket_list();           break;
         case MANAGE_BASKET:           $this->manage_basket();             break;
         case MANAGE_REMOVE_BASKET:    $this->manage_remove_basket($item); break;
         default:                                                          break;
      }
   }

   function get_basket_info() {
      $size = count($_SESSION['basketArray']); 
      print '<br />Basket size: '.$size.' item'.($size>1?'s':'').nl();
   }
}

################################################################################
## Functions end here
################################################################################

// gives back some HTML
class HTMLHelper
{
   var $dhtml_effect;
   var $spaces;
   var $onclick_effect_start; var $onclick_effect_end;
   var $hidden_link_html;

   function HTMLHelper()
   {
      global $presentationAr, $hidden_link;
      
      if ($presentationAr['dhtml'])   $this->dhtml_effect = ' onmouseover="this.style.backgroundColor = \'#D4D4D4\'" onmouseout="this.style.backgroundColor = \'\'"';
      else                           $this->dhtml_effect = '';
      #
      $this->onclick_effect_start = ' onclick="window.location.href=\'';
      $this->onclick_effect_end = '\'"';
      #
      if ($hidden_link['allow']) $this->hidden_link_html = '<img src="' . $hidden_link['pic'] . '" border="'. ($hidden_link['visible']?1:0) .'">';
      else                       $this->hidden_link_html = '';
      #
      $this->spaces = $this->create_spaces($presentationAr['nu_spaces']);
   }

   function table_open() {
      global $presentationAr;

      $table =& $presentationAr['table'];

      if (!$GLOBALS['download_list']) 
         return '<table border="'.$table['border'].'" cellpadding="'.$table['cellpadding'].'" cellspacing="'.$table['cellspacing'].'" width="'.$table['width'].'">' . n();
   }

   function table_close() {
      return '</table>' . n();
   }

   function tr_open() {
      return '<tr'.$this->dhtml_effect.'>';
   }

   function tr_close() {
      return '</tr>';
   }

   //multiplies "&nbsp;" (the non-breakable space)
   function create_spaces($nu) {
      $spaces = '';
      for ($i=0; $i<$nu; ++$i) $spaces .= SPACE;
      return $spaces;
   }

   // length of dots plus formatted filesize will be equal with $presentationAr['max_width'] (right-adjusting)
   function create_dots($size)
   {
      for ($dot=1, $i=0; $i<$size; ++$i) 
      {
         $dot==1 ? $line.='.' : $line.=' ';
         $dot = 1 - $dot;
      }
      return strrev($line);
   }

   function tab($nu) {
      for ($i=0; $i < $nu * TABWIDTH; ++$i) $spaces .= ' ';
      return $spaces;
   }

   //the beginning of the generated page
   function print_start_html($current_dir)
   {
      global $meta_informationAr, $BASE_URL;

      $title = $meta_informationAr['title'];
      
      print <<<END
<html>
<head>
   <title>$title -- $current_dir</title>
   <meta name="author" content="Laszlo Szathmary, alias Jabba">
   <meta name="title"  content="Jabba's PHP Traverser">
   <link rel="stylesheet" type="text/css" href="$BASE_URL/css_js/stylesheet.css">
   <script language="JavaScript" src="$BASE_URL/css_js/open_win.js"></script>
</head>
<body>

END;
   }

   function print_end_html($powered=1)
   {
      if ($powered)
         print '<font size="-1">'.
               'Powered by <a href="http://www.hotscripts.com/Detailed/16749.html">'."Jabba's PHP Traverser".'</a>'.
               ' 2002 -- 2003</font>'.nl();
      print <<< END
</body>
</html>

END;
   }

   function print_download_list_button()
   {
      global $dir, $PHP_SELF, $presentationAr;

      $downloadButtonText = $presentationAr['downloadButtonText'];
      $action =    "javascript: open_download_list_win('$PHP_SELF?dir=".urlencode(urlencode($dir))."&download_list=1')";
      print <<< END
<form name="download_list" method="GET" action="$action">
   <hr>
   <input type="submit" class="formbutton" value="$downloadButtonText">
   <hr>
</form>

END;
   }

   function print_current_directory_description() {
      global $currentDirDescription;

      if (strlen($currentDirDescription)>0)
         print '<font class="tgtext">Description: </font><i>'.$currentDirDescription.'</i><br />' . n();
   }

} // end of class HTMLHelper

?>
